import cv2
import numpy as np
import requests
from abc import ABC, abstractmethod


class IIIFAbstractManifest(ABC):
    """
    An abstract class for handling IIIF manifests for further processing.
    """
    def __init__(self, manifest_url):
        self.manifest_url = manifest_url
        super().__init__()

    @abstractmethod
    def _load_single_image(self):
        pass

    @abstractmethod
    def _load_multiple_images(self):
        pass

    @abstractmethod
    def get_image(self):
        pass

    @abstractmethod
    def get_images(self):
        pass

    @abstractmethod
    def get_image_range(self):
        pass


class IIIFColorizer(IIIFAbstractManifest):
    pass


class IIIFImageStitcher(IIIFAbstractManifest):
    pass
